import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import textwrap

exercise = 'src.most_common_character'
function = 'most_common_character'

def get_correct(test_case: str) -> str:
    return max([(test_case.count(x), x) for x in test_case])[1]

def f(mj):
    return f'"{mj}"'

@points('1.most_common_character')
class MostCommonCharacterTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
           cls.module = load_module(exercise, 'en')

    def test_0_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_1_function_exists(self):
        try:
            from src.most_common_character import most_common_character
        except:
            self.assertTrue(False, 'Din kod bör innehålla en funktion som heter most_common_character(my_string: str)' )
        try:
            from src.most_common_character import most_common_character
            most_common_character("abc")
        except:
            self.assertTrue(False, 'Se till att den funktionen kan anropas som most_common_character("abc")' )

    def test_2_type_of_return_value(self):
        most_common_character = load(exercise, function, 'en')
        val = most_common_character("abc")
        self.assertTrue(type(val) == str, 'Funktion most_common_character returnerar inte värdet av strängtyp när most_common_character("abc") anropas')
    
    def test_3_one_word(self):
        for test_case in ["aaabb", "aabbbbc", "abcabca","xyzxyzyyxyz", "composer"]:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                most_common_character = load(exercise, function, 'en')
                
                correct = get_correct(test_case)
                test_result = most_common_character(test_case)

                self.assertEqual(correct, test_result, f"Resultatet {test_result} matchar inte det förväntade resultatet {correct} när most_common_character({f(test_case)}) anropas")

    def test_4_several_words(self):
        for test_case in ["aaaa bbb ccc ddddd bbb", "she sells seasell", "xyz xyz xyz zzzzorro"]:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                most_common_character = load(exercise, function, 'en')
                
                correct = get_correct(test_case)
                test_result = most_common_character(test_case)

                self.assertEqual(correct, test_result, f"Resultatet {test_result} matchar inte det förväntade resultatet {correct} när most_common_character({f(test_case)}) anropas")
 
if __name__ == '__main__':
    unittest.main()